<template>
    <div>
        <CNav variant="pills" class="mb-3">
            <CNavItem to="?new=true" :active="!!$route.query && !!$route.query.new">НОВЫЕ</CNavItem>
            <CNavItem to="/sku" :active="!$route.query.length">ВСЕ АРТИКУЛЫ И ШТРИХКОДЫ</CNavItem>
        </CNav>
        <q-table :data="items" :columns="fields" class="skuTable">
            <template #bottom>
                <CRow class="w-100 tablePaginationWrapper">
                    <CCol sm="4" class="d-flex justify-start">
                        <CSelect
                            label="Строк в таблице"
                            :options="[10,20,30,40,50]"
                            :horizontal="{ label: 'col-sm-6', input: 'col-sm-6'}"
                            class="w-100 align-content-center font-sm"
                            :value.sync="initialPagination.rowsPerPage"
                        />
                    </CCol>
                    <CCol sm="4" class="d-flex justify-center">
                        <q-pagination
                            v-model="initialPagination.page"
                            color="grey-8"
                            :max="pagesNumber"
                            :max-pages="5"
                            size="md"
                            :boundary-numbers="true"
                        />
                    </CCol>
                    <CCol sm="4" class="d-flex justify-content-end align-items-center">
                        <CLink to="#page" class="font-sm text-dark">
                            Вернуться в начало
                        </CLink>
                    </CCol>
                </CRow>
            </template>
            <template v-slot:header-cell="props">
                <q-th
                    :style="[...props._style]"
                    :class="[...props._classes]"
                    :props="props"
                >
                    <div class="tableHeadInner">
                        {{ props.col.label }}
                        <div class="colResizer" @mousedown.left="hold($event, props.col.name)"/>
                    </div>
                </q-th>
            </template>
            <template #body-cell="props">
                <q-td
                    :props="props"
                    :style="[...props.col._style]"
                    :class="[props.col._classes]"
                >
                    <div class="tableCellInner">
                        {{ props.value }}
                        <div class="colResizer" @mousedown.left="hold($event, props.col.name)"/>
                        <div class="rowResizer" @mousedown.left="hold($event, props.col.name, 'v')"/>
                    </div>
                </q-td>
            </template>
            <template v-slot:body-cell-action="props">
                <q-td :props="props">
                    <CButton
                        variant="ghost"
                        class="commentButton"
                        @click="!props.row.edit
                        ? itemEdit(props.row.id)
                        : fieldSubmit(props.row.id)"
                    >
                        <CIcon :name="!props.row.edit ? 'cil-pencil' : 'cil-check-circle'" size="xl"/>
                    </CButton>
                </q-td>
            </template>
            <template v-slot:body-cell-tds_barcode="props">
                <q-td
                    :props="props"
                    :style="[...props.col._style]"
                >
                    <form
                        class="tableCellInner"
                        @submit.prevent="fieldSubmit(props.row.id)"
                        :ref="`tds_barcode-${props.rowIndex}`"
                    >
                        <CSelect
                            v-if="currentItem === props.row.id"
                            :options="barcodeVariants"
                            :value.sync="props.row.tds_barcode"
                            type="number"
                        />
                        <span v-if="currentItem !== props.row.id">{{ props.row.tds_barcode }}</span>
                        <div class="colResizer" @mousedown.left="hold($event, props.col.name)"/>
                        <div class="rowResizer" @mousedown.left="hold($event, props.col.name, 'v')"/>
                    </form>
                </q-td>
            </template>
            <template v-slot:body-cell-tds_article="props">
                <q-td
                    :props="props"
                    :style="[...props.col._style]"
                >
                    <form
                        class="tableCellInner"
                        @submit.prevent="fieldSubmit(props.row.id)"
                    >
                        <CInput
                            v-if="currentItem === props.row.id"
                            :value.sync="props.row.tds_article"
                            :list="`list-${props.rowIndex}`"
                            autocomplete="off"
                        />
                        <datalist
                            v-if="currentItem === props.row.id"
                            :id="`list-${props.rowIndex}`"
                        >
                            <option :value="item" v-for="(item, i) in skuVariants" :key="`${i}-${props.rowIndex}`"/>
                        </datalist>
                        <span v-if="currentItem !== props.row.id">{{ props.row.tds_article }}</span>
                        <div class="colResizer" @mousedown.left="hold($event, props.col.name)"/>
                        <div class="rowResizer" @mousedown.left="hold($event, props.col.name, 'v')"/>
                    </form>
                </q-td>
            </template>
            <template #no-data>
                <TableNoData/>
            </template>
        </q-table>
    </div>
</template>

<script>
import {mapGetters} from "vuex";

export default {
    name: "Sku",
    data() {
        return {
            holdingKey: null,
            offset: 0,
            startOffset: 0,
            resizableEl: null,
            initialPagination: {
                sortBy: 'desc',
                descending: false,
                page: 1,
                rowsPerPage: 20
            },
            skuVariants: [],
            barcodeVariants: [],
            currentItem: null
        }
    },
    created() {
        this.getSKUList();
    },
    watch: {
        'specified': { // Фильтрация данных новые/все
        	handler: function (value) {
                this.changePreloaderState(true, 'Получение данных');
                this.$store.dispatch('sku/getSkuList', {specified: value})
                    .catch(() => {
                        this.$store.dispatch('toast/addToast', {
                            toastInfo: 'Ошибка при получении данных',
                            isVisibleToast: true,
                            type: 'success'
                        })
                    })
                    .finally(() => this.changePreloaderState(false, ''))
            },
            deep: true
        }
    },
    computed: {
        ...mapGetters("sku", {
            items: "get",
            fields: "getFields",
        }),
        pagesNumber() {
            return Math.ceil(this.items.length / this.initialPagination.rowsPerPage)
        },
        specified() {
            return !this.$route.query.new
        }
    },
    methods: {
        hold(e, key, direction = 'h') {
            this.holding = true
            const el = e.target.parentNode.parentNode
            this.resizableEl = el
            this.startOffset = (direction === 'h')
                ? el.offsetWidth - e.pageX
                : el.offsetHeight - e.pageY
            this.holdingKey = key
            this.holdingDirection = direction
            el.style.userSelect = 'none'
            document.addEventListener('mousemove', this.moving)
            document.addEventListener('mouseup', this.unhold)
        },
        unhold() {
            this.holding = false
            this.holdingKey = null
            this.holdingDirection = null
            this.resizableEl.style.userSelect = null
            document.removeEventListener('mousemove', this.moving)
            document.removeEventListener('mouseup', this.unhold)
        },
        moving(e) {
            const move = () => window.requestAnimationFrame(
                () => {
                    if (this.holding) {
                        if (this.holdingDirection === 'h') {
                            const width = this.startOffset + e.pageX
                            this.offset = width
                            this.resizableEl.style.minWidth = `${width}px`
                            this.updateLeftOffset()
                            this.$store.dispatch('setColWidth', {width, name: this.holdingKey})
                        } else {
                            const height = this.startOffset + e.pageY
                            this.offset = height
                            this.resizableEl.style.height = `${height}px`
                            this.updateLeftOffset()
                            this.$store.dispatch('setColHeight', {height, name: this.holdingKey})
                        }
                    }
                }
            )
            move()
        },
        updateLeftOffset() {
            let offset = 0
            const firstRow = this.$el.querySelectorAll('thead>tr:nth-child(1) > .left-sticky')
            const tableRows = this.$el.querySelectorAll('tbody>tr')
            this.$el.querySelectorAll('thead>tr:first-child > .left-sticky').forEach((el, index, array) => {
                const setOffset = () => window.requestAnimationFrame(
                    () => {
                        if (index > 0) {
                            const prevEl = array[index - 1]
                            offset += prevEl.clientWidth
                        }
                        el.style.left = `${offset}px`
                        firstRow[index].style.left = `${offset}px`
                    }
                )
                offset = 0
                setOffset()
                tableRows.forEach(row => {
                    const setBodyCellsOffset = () => window.requestAnimationFrame(
                        () => {
                            if (index > 0) {
                                const currentCell = row.querySelectorAll('.position-sticky')[index]
                                if (currentCell) currentCell.style.left = `${offset}px`
                            }
                        }
                    )
                    setBodyCellsOffset()
                })
            })
        },
        fieldSubmit(id) {
            const item = this.items.find(item => item.id === id);
            this.changePreloaderState(true, 'Сохранение данных')
            this.$store.dispatch('sku/edit', {
                id: item.id,
                tds_article: item.tds_article,
                tds_barcode: item.tds_barcode,
                product_info_id: item.product_info_id
            })
            .then(()=> {
                this.currentItem = null
            })
            .catch(error => {
                Object.values(error.response.data.data.errors).forEach(item => {
                    item.forEach(deepItem=> {
                        this.$store.dispatch('toast/addToast', {
                            toastInfo: deepItem,
                            isVisibleToast: true,
                            toastLevel: 1
                        })
                    })
                })
            })
            .finally(() => this.changePreloaderState(false, ''))

        },
        itemEdit(id) {
            const item = this.items.find(result => result.id === id);
            this.changePreloaderState(true, 'Получение данных');
            this.$store.dispatch('sku/getSkuVariants', {sku: item.platform_article})
                .then(({data}) => {
                    this.skuVariants = data.data.map(item => (item.sku))
                    this.barcodeVariants = ['',...data.data.map(item => (item.barcode))]
                    this.$set(item, 'edit', true)
                    this.currentItem = id
                })
                .finally(() => this.changePreloaderState(false, ''))
        },
        getSKUList() {
            this.changePreloaderState(true, 'Получение данных');
            this.$store.dispatch('sku/getSkuList', {specified: !!this.specified})
                .finally(() => this.changePreloaderState(false, ''))
        }
    }
};
</script>
